import { Component, EventEmitter, Input, Output, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
export interface DataModel {
  code: string,
  behaviorIndicators: string[],
  assessmentTools: AssessmentToolsModal[][],
  curriculum: CurriculumModal[]
}
export interface AssessmentToolsModal {
  code: string,
  name: string,
  nameShow: string,
}
export interface CurriculumModal {
  code: string,
  name: string
}
@Component({
  selector: 'app-edit-group-indicators',
  templateUrl: './edit-group-indicators.html',
  styleUrls: ['./edit-group-indicators.scss']
})
export class EditGroupIndicators implements OnInit {
  @Output() sendEdit: EventEmitter<boolean> = new EventEmitter<boolean>();
  search = ""
  currentPage = 1
  page = Array.from({ length: 1 }, (_, i) => i + 1);
  dataList: DataModel[] = [
    {
      code: "1", behaviorIndicators: ["ปฏิบัติงานโดยให้ความสำคัญกับเรื่องความปลอดภัยเป็นอันดับแรก (Safety First) สวมใส่อุปกรณ์ป้องกันเพื่อความปลอดภัย ระวังสิ่งที่อาจะเป็นสาเหตุของอุบัติเหตุรอบๆตัวให้เป็นไปตามมาตรฐานด้านความปลอดภัย และคุณภาพ", "ปฏิบัติงานตามมาตรฐานด้านความปลอดภัยและคุณภาพของหน่วยงาน", "ปฎิบัติงานไม่ให้เกิดอุบัติเหตุ และรักษาคุณภาพตามความรับผิดชอบอย่างมีประสิทธิภาพ เช่นการควบคุมปริมาณของเสีย (Defect) การแก้ไขงาน(Rework) หรือการหยุดรองาน (Delay) ของทีมงานให้น้อยที่สุด", "มีความพร้อมในการทำงานทุกๆวัน ทั้งเรื่องวินัย มาตรฐานการทำงาน และหน้าที่ตามใบกำหนดหน้าที่งาน"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" }
	  ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }]
	  ,[
        { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-01", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O1-O2" }]
    },
    {
      code: "2", behaviorIndicators: ["ควบคุมการทำงานโดยให้ความสำคัญกับเรื่องความปลอดภัยเป็นอันดับแรก (Safety First) สวมใส่อุปกรณ์ป้องกันเพื่อความปลอดภัย ระวังสิ่งที่อาจะเป็นสาเหตุของอุบัติเหตุรอบๆตัวให้เป็นไปตามมาตรฐานด้านความปลอดภัย และคุณภาพ",
	  "รวบรวมข้อมูล ปริมาณของเสีย (Defect)ด้านความปลอดภัยและคุณภาพของหน่วยงานและนำเสนอผู้บังคับบัญชาได้อย่างถูกต้องและทันเวลา",
	  "ดูแลการปฎิบัติงานของทีมงานไม่ให้เกิดอุบัติเหตุ และรักษาคุณภาพตามความรับผิดชอบอย่างมีประสิทธิภาพ เช่นการควบคุมปริมาณของเสีย (Defect) การแก้ไขงาน(Rework) หรือการหยุดรองาน (Delay) ของทีมงานให้น้อยที่สุด",
	  "รายงานข้อมูล ในการแก้ไขปัญหาให้กับผู้บังคับบัญชาตามมาตรฐานที่กำหนดไว้ เพื่อไม่ให้เกิดปัญหาซ้ำ"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" }
	  ]
	  ,[
	    { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-02", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O3-O4" }]
    },
	{
      code: "3", behaviorIndicators: ["จัดทำมาตรฐานด้านความปลอดภัย และคุณภาพของหน่วยงานเชื่อมโยงกับนโยบายบริษัท",
	  "ทบทวนและปรับปรุงการปฏิบัติงานของทีมงานให้เป็นไปตามนโยบายด้านความปลอดภัยและคุณภาพ",
	  "อธิบายและสื่อสารข้อมูลด้านความปลอดภัยและคุณภาพในหน่วยงานที่รับผิดชอบอย่างมีประสิทธิภาพ",
	  "แก้ไขปัญหาเบื้องต้นด้านความปลอดภัยและคุณภาพในหน่วยงานที่รับผิดชอบ"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" },
       { code: "D", nameShow: "D", name: "D" }
	  ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-03", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S1-S2" }]
    },
	{
      code: "4", behaviorIndicators: ["สอนงานด้านความปลอดภัย และคุณภาพของบริษัทให้กับพนักงานในหน่วยงาน",
	  "ติดตามและปรับปรุงการทำงานด้านความปลอดภัยและคุณภาพของทีมงาน",
	  "คิดวิเคราะห์เพื่อแก้ปัญหาด้านความปลอดภัยและคุณภาพในหน่วยงานที่รับผิดชอบ",
	  "นำเสนอและจัดทำรายงานด้านความปลอดภัยและคุณภาพทั้งภาษาไทยและภาษาอังกฤษ"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" }
	  ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-04", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S3-S4" }]
    },
	{
      code: "5", behaviorIndicators: ["เป็นพี่เลี้ยงโดยสามารถให้คำปรึกษาพนักงานเพื่อสนับสนุนนโยบายด้านความปลอดภัย และคุณภาพของบริษัท",
	  "วางแผนด้านความปลอดภัยและคุณภาพในหน่วยงานที่รับผิดชอบ",
	  "ตัดสินใจเพื่อให้เกิดความปลอดภัยและคุณภาพ",
	  "สร้างความร่วมมือระหว่างหน่วยงานเพื่อให้เกิดความปลอดภัยและคุณภาพที่มีประสิทธิภาพ"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" }
	  ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-05", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M1-M2" }]
    },
	{
      code: "6", behaviorIndicators: ["เป็นโค้ช และผู้สนับสนุนนโยบายด้านความปลอดภัย และคุณภาพของบริษัท",
	  "สร้างกลยุทธ์ด้านความปลอดภัยและคุณภาพในหน่วยงานที่รับผิดชอบ",
	  "เป็นผู้นำในการทำงานด้วยจิตสำนึกด้านความปลอดภัยและคุณภาพในหน่วยงานที่รับผิดชอบ",
	  "สื่อสารนโยบายการพัฒนาและปรับปรุงระบบความปลอดภัยและคุณภาพในเชิงบวกให้กับพนักงานเป็นไปตามทิศทางเดียวกับนโยบายบริษัท"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" }
	  ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-06", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M3-M4" }]
    },
	{
      code: "7", behaviorIndicators: ["เชื่อมโยงนโยบายด้านความปลอดภัย และคุณภาพของบริษัทกับผู้บริหาร",
	  "จัดการให้เป็นไปตามกลยุทธ์และทิศทางด้านความปลอดภัยและคุณภาพตามสายงานที่รับผิดชอบ",
	  "เป็นผู้นำในการสร้างวัฒนธรรมองค์กรให้พนักงานมีจิตสำนึกด้านความปลอดภัยและคุณภาพในสายงานที่รับผิดชอบ",
	  "ตัดสินใจด้านความปลอดภัยและคุณภาพในสายงานที่รับผิดชอบโดยผ่านทางคณะกรรมการฯ"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" },
       { code: "D", nameShow: "D", name: "D" }
	  ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-07", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ E1-E2" }]
    },
	{
      code: "8", behaviorIndicators: ["กำหนดนโยบายด้านความปลอดภัย และคุณภาพของบริษัท",
	  "บริหารงานให้เป็นไปตามกลยุทธ์และทิศทางด้านความปลอดภัยและคุณภาพ",
	  "เป็นผู้นำในการสร้างวัฒนธรรมองค์กรให้พนักงานมีจิตสำนึกด้านความปลอดภัยและคุณภาพ",
	  "ตัดสินใจด้านความปลอดภัยและคุณภาพ"]
	  , assessmentTools: [
	  [
	   { code: "O", nameShow: "O", name: "O" },
       { code: "D", nameShow: "D", name: "D" }
	  ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" },
        { code: "D", nameShow: "D", name: "D" }
	   ]
	  ,[
	    { code: "O", nameShow: "O", name: "O" }
	   ]
	  ,[
        { code: "O", nameShow: "O", name: "O" }
	   ]
	  ]
	  , curriculum: [{ code: "CC-01-08", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ E3-E4" }]
    },

  ]
  dataSelect?: DataModel
  assessmentToolsSelect: number = -1

  searchModal = ""
  currentPageModal = 1
  pageModal = Array.from({ length: 1 }, (_, i) => i + 1);

  assessmentToolsList: AssessmentToolsModal[] = [
    { code: "01", nameShow: "O", name: "แบบสังเกต" },
    { code: "02", nameShow: "D", name: "แบบการปฏิบัติงาน" },
    { code: "03", nameShow: "P", name: "การบันทึก/เอกสาร" },
    { code: "04", nameShow: "I", name: "การสัมภาษณ์" },
    { code: "05", nameShow: "T", name: "แบบทดสอบ" }
  ]


  curriculumList: CurriculumModal[] = [
    { code: "CC-01-01", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O1-O2" },
    { code: "CC-01-02", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O3-O4" },
    { code: "CC-01-03", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S1-S2" },
    { code: "CC-01-04", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S3-S4" },
    { code: "CC-01-05", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M1-M2" },
    { code: "CC-01-06", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M3-M4" }
  ]


  ngOnInit() {
    this.searchChange()
  }
  onEdit() {
    this.sendEdit.emit(false);
  }
  searchChange() {
    this.currentPage = 1;
    const filteredData = this.dataListFilter();
    this.page = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  dataListFilter() {
    return this.dataList.filter(x => {
      const match = x.code.includes(this.search);
      return match;
    });
  }

  assessmentToolsModalSearchChange() {
    this.currentPageModal = 1;
    const filteredData = this.assessmentToolsListFilter();
    this.pageModal = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  assessmentToolsListFilter() {
    const dataList = (this.assessmentToolsSelect > -1 && this.dataSelect) ? this.dataSelect.assessmentTools[this.assessmentToolsSelect] : this.assessmentToolsList
    return dataList.filter(x => {
      const match = x.code.includes(this.searchModal) || x.name.includes(this.searchModal);
      return match;
    });
  }
  curriculumModalSearchChange() {
    this.currentPageModal = 1;
    const filteredData = this.curriculumListFilter();
    this.pageModal = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  curriculumListFilter() {
    const dataList = this.curriculumList
    return dataList.filter(x => {
      const match = x.code.includes(this.searchModal) || x.name.includes(this.searchModal);
      return match;
    });
  }
}
