import { HttpClient, HttpHeaders } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { environment } from 'src/environments/environment';
import { CompetencytypeModel } from '../model/competencytype.model';
@Injectable({
  providedIn: 'root'
})
export class CompetencytypeService {
  api = "/competencytype"
  urlApi = environment.baseUrl + this.api
  constructor(private http: HttpClient) {
  }
  getById(competencyTypeId: string): Observable<CompetencytypeModel> {
    return this.http.get<CompetencytypeModel>(this.urlApi + "/" + competencyTypeId)
  }
  getList(): Observable<CompetencytypeModel[]> {
    return this.http.get<CompetencytypeModel[]>(this.urlApi + "/lists")
  }
  post(body: CompetencytypeModel) {
    return this.http.post(this.urlApi, body)
  }
  delete(body: CompetencytypeModel) {
    const options = {
      headers: new HttpHeaders({
        "Content-Type": "application/json",
      }),
      body: body
    };
    return this.http.delete(this.urlApi, options)
  }
}